<?php

/**
 * @file
 * Administrative page code for the CookiePro module.
 */

/**
 * Administrative settings.
 *
 * @return array

 */
function cookiepro_ccpa_settings($form, &$form_state) {
    $default_settings = variable_get('cookiepro_ccpa_settings');
    $form['cookiepro_ccpa']['isLinkEnabled'] = [
        '#type' => 'radios',
        '#title' => t('Opt-out Button'),
        '#options' => array( 'text_link' => t('Text Link'), 'button' => t('Button') ),
        '#default_value' => isset( $default_settings['isLinkEnabled'] ) ? $default_settings['isLinkEnabled'] : 'text_link',
        '#prefix' => '<div class="section_one allsections">'
    ];

    $form['cookiepro_ccpa']['link_text'] = [
        '#type' => 'textfield',
        '#title' => t(''),
        '#value' => '<a id="otCCPAdoNotSellLink" href="javascript:void(0);" data-ot-ccpa-opt-out="button" style="display:none;">Do Not Sell My Personal Information</a>',
        '#description' => 'Copy and paste the above snippet onto your website.',
        '#attributes' => array('readonly' => 'readonly'),
        '#prefix'     => '<div class="copybuttontext">'
    ];

    $form['cookiepro_ccpa']['copy_button'] = [
        '#type' => 'button',
        '#title' => t(''),
        '#value' => 'Copy',
        '#suffix' => '</div>',
        '#attributes' => [
            'onclick' => 'return false;'
        ]           
    ];
    $form['cookiepro_ccpa']['button_text'] = [
        '#type' => 'textfield',
        '#title' => t(''),
        '#value' => '<button type="button" data-ot-ccpa-opt-out="button" style="display:none;" class="ot-ccpa-optout__button ot-ccpa-optout__button--light"><img src="https://cookie-cdn.cookiepro.com/ccpa-optout-solution/v1/assets/icon-do-not-sell.svg" style="width:30px;height:30px;" alt="" role="presentation"><span class="ot-ccpa-optout__button__title">Do Not Sell My Personal Information</span></button>',
        '#description' => 'Copy and paste the above snippet onto your website.',
        '#attributes' => array('readonly' => 'readonly'),
        '#prefix'     => '<div class="copybuttontext2">'
    ];
    $form['cookiepro_ccpa']['copy_button2'] = [
        '#type' => 'button',
        '#title' => t(''),
        '#value' => 'Copy',
        '#suffix' => '</div></div>',
        '#attributes' => [
            'onclick' => 'return false;'
        ]           
    ];      
    $form['cookiepro_ccpa']['isButtonEnabled'] = [
        '#type' => 'checkbox',
        '#title' => t('Floating Button'),
        '#default_value' => isset( $default_settings['isButtonEnabled'] ) ? $default_settings['isButtonEnabled'] : 0,
        '#prefix' => '<div class="section_two allsections">'
    ];
    $form['cookiepro_ccpa']['Image_Icon'] = [
        '#type' => 'managed_file',
        '#title' => t('Icon'),
        '#upload_location' => 'public://ccpamoduleicon',
        '#upload_validators' => [
            'file_validate_extensions' => ['png', 'jpeg', 'jpg'],
        ],
        '#default_value' => isset( $default_settings['Image_Icon'] ) ? $default_settings['Image_Icon'] : '',
        '#theme' => 'image_widget',
        '#preview_image_style' => 'medium',
    ];
    $form['#attached']['css'] = array(
      drupal_get_path('module', 'cookiepro_ccpa') . '/css/colorpicker.css',
      drupal_get_path('module', 'cookiepro_ccpa') . '/css/cookiepro_ccpa-layout.css',
    ); 
    $form['#attached']['js'] = array(
      drupal_get_path('module', 'cookiepro_ccpa') . '/js/colorpicker.js',
      drupal_get_path('module', 'cookiepro_ccpa') . '/js/custom.js',
    );    
    $form['cookiepro_ccpa']['buttonBackgroundColor'] = [
        '#type' => 'textfield',
        '#title' => t('Button Background'),
        '#default_value' => isset( $default_settings['buttonBackgroundColor'] ) ? $default_settings['buttonBackgroundColor'] : '#6699cc',
        '#prefix' => '</div><div class="section_three allsections">'
    ];
    $form['cookiepro_ccpa']['button_text_color'] = [
        '#type' => 'textfield',
        '#title' => t('Button Text'),
        '#default_value' => isset( $default_settings['button_text_color'] ) ? $default_settings['button_text_color'] : '#ffffff',
    ];
    $form['cookiepro_ccpa']['header_icon_background'] = [
        '#type' => 'textfield',
        '#title' => t('Header and Icon Background '),
        '#default_value' => isset( $default_settings['header_icon_background'] ) ? $default_settings['header_icon_background'] : '#6699cc',
    ];
    $form['cookiepro_ccpa']['header_text_color'] = [
        '#type' => 'textfield',
        '#title' => t('Header Text'),
        '#default_value' => isset( $default_settings['header_text_color'] ) ? $default_settings['header_text_color'] : '#ffffff',
    ];
    $form['cookiepro_ccpa']['button_position'] = [
        '#type' => 'radios',
        '#title' => t('Button Position'),
        '#options' => array( 'left' => t('Left'), 'right' => t('Right') ),
        '#default_value' => isset( $default_settings['button_position'] ) ? $default_settings['button_position'] : 'right',
        '#suffix' => '</div>'
    ];

    $form['button_settings']['popup_main_title'] = [
        '#type' => 'textfield',
        '#title' => t('Title'),
        '#default_value' => isset( $default_settings['popup_main_title'] ) ? $default_settings['popup_main_title'] : 'Do Not Sell My Personal Information',
        '#prefix' => '<div class="section_four allsections">'   
    ];
    $form['button_settings']['PrivacyPolicyMessage'] = [
        '#type' => 'textarea',
        '#title' => t('Message'),
        '#default_value' => isset( $default_settings['PrivacyPolicyMessage'] ) ? $default_settings['PrivacyPolicyMessage'] : 'Exercise your consumer rights by contacting us below',
    ];
    $form['button_settings']['privacy_text'] = [
        '#type' => 'textfield',
        '#title' => t('Policy Label'),
        '#default_value' => isset( $default_settings['privacy_text'] ) ? $default_settings['privacy_text'] : 'Privacy Policy',
    ];
    $form['button_settings']['privacy_link'] = [
        '#type' => 'textfield',
        '#title' => t('Policy URL'),
        '#default_value' => isset( $default_settings['privacy_link'] ) ? $default_settings['privacy_link'] : '',
        '#suffix' =>'</div>'
    ];
    $form['button_settings']['selectuseroption'] = [
        '#type' => 'radios',
        '#title' => t('Select User Access'),
        '#options' => array( 
            'all' => t('Show to all users'), 
            'US' => t('Show only to users from the US'),
            'California' => t('Show only to users from california')
        ),
        '#default_value' => isset( $default_settings['selectuseroption'] ) ? $default_settings['selectuseroption'] : 'all',
        '#prefix' => '<div class="section_five allsections">',
        '#suffix' => '</div>'
    ];
    $form['button_settings']['isEmailEnabled'] = [
        '#type' => 'checkbox',
        '#title' => t('Display Email Address?'),
        '#description' => t('If a site visitor clicks the Do Not Sell Button, they will be provided with the email address entered below that they can contact if further action is needed to complete the consumer rights request. <a href="https://www.cookiepro.com/data-subject-rights/" target="_blank">Learn More</a>'),
        '#default_value' => isset( $default_settings['isEmailEnabled'] ) ? $default_settings['isEmailEnabled'] : 1,
        '#prefix' => '<div class="section_six allsections">'
    ];
    $form['button_settings']['emailAddress'] = [
        '#type' => 'textfield',
        '#title' => t('Email Address'),
        '#default_value' => isset( $default_settings['emailAddress'] ) ? $default_settings['emailAddress'] : '',
        '#suffix' => '</div>'
    ];
    $form['button_settings']['isPhoneEnabled'] = [
        '#type' => 'checkbox',
        '#title' => t('Display Phone Number?'),
        '#description' => t('If a site visitor clicks the Do Not Sell Button, they will be provided with the phone number entered below that they can contact if further action is needed to complete the consumer rights request. <a href="https://www.cookiepro.com/data-subject-rights/" target="_blank">Learn More</a>'),
        '#default_value' => isset( $default_settings['isPhoneEnabled'] ) ? $default_settings['isPhoneEnabled'] : 1,
        '#prefix' => '<div class="section_seven allsections">'
    ];
    $form['button_settings']['phoneNumber'] = [
        '#type' => 'textfield',
        '#title' => t('Phone Number'),
        '#default_value' => isset( $default_settings['phoneNumber'] ) ? $default_settings['phoneNumber'] : '',
        '#suffix' => '</div>'
    ];

    $form['button_settings']['form_enable'] = [
        '#type' => 'checkbox',
        '#title' => t('Consumer Rights Request Form'),
        '#description' => t('Display link to Consumer Rights Request form. Sign up to get access to your own Data Subject Request portal for free. <a href="https://www.cookiepro.com/data-subject-rights/" target="_blank">Learn More</a>'),
        '#default_value' => isset( $default_settings['form_enable'] ) ? $default_settings['form_enable'] : 1,
        '#prefix' => '<div class="section_eight allsections">'
    ];
    $form['button_settings']['form_link_text'] = [
        '#type' => 'textfield',
        '#title' => t('Link Label'),
        '#default_value' => isset( $default_settings['form_link_text'] ) ? $default_settings['form_link_text'] : 'Exercise Your Rights',
    ];
    $form['button_settings']['form_link_url'] = [
        '#type' => 'textfield',
        '#title' => t('Form URL'),
        '#default_value' => isset( $default_settings['form_link_url'] ) ? $default_settings['form_link_url'] : '',
        '#suffix' => '</div>'
    ];

    $form['button_settings']['isGooglePersonalizeEnabled'] = [
        '#type' => 'checkbox',
        '#title' => t('Opt-out of Ad Partners'),
        '#description' => t('Disable Google and its technology partners from collecting data and using cookies for advertisements personalization and measurement.'),
        '#default_value' => isset( $default_settings['isGooglePersonalizeEnabled'] ) ? $default_settings['isGooglePersonalizeEnabled'] : 1,
        '#prefix' => '<div class="section_nine allsections">'
    ];
    $form['button_settings']['isIABEnabled'] = [
        '#type' => 'checkbox',
        '#title' => t('Utilize the IAB CCPA framework to Opt-out of Sale'),
        '#default_value' => isset( $default_settings['isIABEnabled'] ) ? $default_settings['isIABEnabled'] : 0,
        '#prefix' => '<div class="personalizegroup">'
    ];
    $form['button_settings']['isLSPAenable'] = [
        '#type' => 'checkbox',
        '#title' => t('My business has signed the IAB Limited Service Provider Agreement.'),
        '#default_value' => isset( $default_settings['isLSPAenable'] ) ? $default_settings['isLSPAenable'] : 0,
    ];    
    $form['button_settings']['googleConfirmationTitle'] = [
        '#type' => 'textfield',
        '#title' => t('Toggle Label'),
        '#default_value' => isset( $default_settings['googleConfirmationTitle'] ) ? $default_settings['googleConfirmationTitle'] : 'Personalized advertisements',
    ];
    $form['button_settings']['googleConfirmationMessage'] = [
        '#type' => 'textarea',
        '#title' => t('Message'),
        '#default_value' => isset( $default_settings['googleConfirmationMessage'] ) ? $default_settings['googleConfirmationMessage'] : 'Turning this off will opt you out of personalized advertisements delivered from Google on this website.',
    ];
    $form['button_settings']['confirmbutton'] = [
        '#type' => 'textfield',
        '#title' => t('Confirm Label'),
        '#default_value' => isset( $default_settings['confirmbutton'] ) ? $default_settings['confirmbutton'] : 'Confirm',
        '#suffix' => previewhtml()
    ];    

    $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => 'Save  Configuration',
    );

    return $form;
}

/**
 * Submit handler().
 */
function cookiepro_ccpa_settings_submit($form, &$form_state) {

    $file = file_load( $form_state['values']['Image_Icon'] );

    if( ! empty( $file ) ){
        $file->status = FILE_STATUS_PERMANENT;
        file_save($file);
        //$img = cookiepro_ccpa_load_icon('ccpaicon');
        file_usage_add($file, 'cookiepro_ccpa', 'image', 1, 1);
    }

    $settings['isLinkEnabled'] = $form_state['values']['isLinkEnabled'];
    $settings['isButtonEnabled'] = $form_state['values']['isButtonEnabled'];
    $settings['buttonBackgroundColor'] = $form_state['values']['buttonBackgroundColor'];
    $settings['button_text_color'] = $form_state['values']['button_text_color'];
    $settings['header_icon_background'] = $form_state['values']['header_icon_background'];
    $settings['header_text_color'] = $form_state['values']['header_text_color'];  
    $settings['button_position'] = $form_state['values']['button_position'];

    $settings['popup_main_title'] = $form_state['values']['popup_main_title'];
    $settings['PrivacyPolicyMessage'] = $form_state['values']['PrivacyPolicyMessage'];
    $settings['privacy_text'] = $form_state['values']['privacy_text'];
    $settings['privacy_link'] = $form_state['values']['privacy_link'];
    $settings['selectuseroption'] = $form_state['values']['selectuseroption'];
    $settings['isEmailEnabled'] = $form_state['values']['isEmailEnabled'];
    $settings['emailAddress'] = $form_state['values']['emailAddress'];

    $settings['Image_Icon'] = $form_state['values']['Image_Icon'];
    $settings['isPhoneEnabled'] = $form_state['values']['isPhoneEnabled'];
    $settings['phoneNumber'] = $form_state['values']['phoneNumber'];
    $settings['form_enable'] = $form_state['values']['form_enable'];
    $settings['form_link_text'] = $form_state['values']['form_link_text'];
    $settings['form_link_url'] = $form_state['values']['form_link_url'];
    $settings['isGooglePersonalizeEnabled'] = $form_state['values']['isGooglePersonalizeEnabled'];
    $settings['isLSPAenable'] = $form_state['values']['isLSPAenable'];
    $settings['isIABEnabled'] = $form_state['values']['isIABEnabled'];
    $settings['googleConfirmationTitle'] = $form_state['values']['googleConfirmationTitle'];
    $settings['googleConfirmationMessage'] = $form_state['values']['googleConfirmationMessage'];
    $settings['confirmbutton'] = $form_state['values']['confirmbutton'];

    variable_set('cookiepro_ccpa_settings', $settings);
    drupal_set_message(t('The configuration options have been saved'));
}


function previewhtml(){

    $ccpa_settings = variable_get('cookiepro_ccpa_settings');
    global $base_url;
    $position_class = '';
    if ( 'left' === $ccpa_settings['button_position'] ) {
        $position_class = 'leftaligncontent';
    }   

    if( $ccpa_settings['Image_Icon'] != 0 ){
        $file = file_load( $ccpa_settings['Image_Icon'] );
        //print_r( $file );
        $uri = $file->uri;
        $image_path = file_create_url( $uri );
    } else {
        $image_path = $base_url .'/' .drupal_get_path('module', 'cookiepro_ccpa') .'/images/icon.png';
    }


    $html = '
        </div></div></div>
        <div class="preview_section">
            <div class="preview_head">
                <span class="settings-text">Preview</span>
                <span class="shortdescription">Save changes to update preview</span>
            </div>
            <div class="form-control-group ot-preview-body">';
    if( 1 === $ccpa_settings['isButtonEnabled'] ){
    $html.=     '<span class="previewheading">Floating Button</span>
                <div class="ot-preview-background ot-preview-screen">
                    <div class="ot-banner-button '.$position_class.'" style="background-color: '.$ccpa_settings['header_icon_background'].';">
                        <img src="'.$image_path .'" alt="CookiePro Do Not Sell" title="CookiePro Do Not Sell">
                    </div>
                </div>';
    }
    $html.='
                <span class="previewheading">Inline Button</span>
                <div class="ot-preview-background ot-preview-screen">
                    <div class="ot-banner-button-two">';
    if( 'button' === $ccpa_settings['isLinkEnabled'] ){
    $html.='            <div type="button" style="display:inline-block;" class="ot-ccpa-optout__button ot-ccpa-optout__button--light">
                            <img src="https://cookie-cdn.cookiepro.com/ccpa-optout-solution/v1/assets/icon-do-not-sell.svg" style="width:30px;height:30px;" alt="" role="presentation"><span class="ot-ccpa-optout__button__title">Do Not Sell My Personal Information</span>
                            <span class="ot-ccpa-optout__button__subtitle"><img style="display:block!important;opacity:1!important;height:25px!important;width:152px!important;" src="https://cookie-cdn.cookiepro.com/ccpa-optout-solution/v1/assets/poweredbycookiepro.svg" title="Powered by CookiePro" alt="Powered by CookiePro"></span>
                        </div>';
    } else{
    $html.=             '<a id="otCCPAdoNotSellLink" href="javascript:void(0);" data-ot-ccpa-opt-out="button">Do Not Sell My Personal Information</a>';
    }
    $html.='                    
                    </div>
                </div>
            </div>  
            <span class="previewheading">Modal</span>
            <div class="ot-preview-background popupbutton popupcloseicon '.$position_class.'">
                <div class="ot-banner-confirmation-popup">
                    <div class="side-popup-column-main" style="background-color: '.$ccpa_settings['header_icon_background'].';color: '.$ccpa_settings['header_text_color'].'">
                        <p class="popup-title-main">'.$ccpa_settings['popup_main_title'].'</p>
                        <p class="ot-confirmation-popup-text">'.$ccpa_settings['PrivacyPolicyMessage'];
                        if ( ! empty( $ccpa_settings['privacy_link'] ) ) {
                            $html.= '
                            <a href="'.$ccpa_settings['privacy_link'].'" target="_blank" style="color: '.$ccpa_settings['header_text_color'].'">'.$ccpa_settings['privacy_text'].'</a>';
                        }
            $html.='    </p>
                        <p class="ot-confirmation-popup-text">';
                        if ( 1 === $ccpa_settings['isEmailEnabled'] && ! empty( $ccpa_settings['emailAddress'] ) ) { 
            $html.='        <span class="email-address-icon">
                                <a href="mailto:'.$ccpa_settings['emailAddress'].'" style="color: '.$ccpa_settings['header_text_color'].'">'.$ccpa_settings['emailAddress'].'</a>
                                <br />
                            </span>';
                            } 
                        if ( 1 === $ccpa_settings['isPhoneEnabled'] && ! empty( $ccpa_settings['phoneNumber'] ) ) { 
            $html.='        <span class="phone-number-icon">
                                <a href="tel:'.$ccpa_settings['phoneNumber'].'" style="color: '.$ccpa_settings['header_text_color'].'">'.$ccpa_settings['phoneNumber'].'</a>
                            </span> <br />';
                            } 
                        if ( 1 === $ccpa_settings['form_enable'] && ! empty( $ccpa_settings['form_link_url'] ) ) {
            $html.='        <span class="form-link-icon">
                                <a href="'.$ccpa_settings['form_link_url'].'" target="_blank" style="color: '.$ccpa_settings['header_text_color'].'">'.$ccpa_settings['form_link_text'].'</a>
                            </span>';
                            }
            $html.='    </p>
                    </div>
                    <div class="personal-info">
                        <div class="ot-confirmation-popup-header">
                            <p class="personal-info-title">'.$ccpa_settings['googleConfirmationTitle'].'</p>
                            <label class="ot-toggle-switch googleConfirmation">
                                <input type="checkbox" name="ConfirmationEnabled" id="ConfirmationEnabled" checked="">
                                <span class="ot-toggle-slider sliderinfo round"></span>
                            </label>
                            <div class="clearboth"></div>                       
                        </div>
                        <p class="ot-confirmation-popup-text">'.$ccpa_settings['googleConfirmationMessage'].'</p>                   
                    </div>  
                                                                                
                    <div class="popup-footer">  
                        <div class="powered-by-icon">
                            <img src="'.$base_url .'/' .drupal_get_path('module', 'cookiepro_ccpa') .'/images/PoweredByCookiePro.svg" alt="CookiePro" title="CookiePro">
                        </div>
                        <div class="ot-banner-button ConfirmBtn" style="background-color:'.$ccpa_settings['buttonBackgroundColor'].';">
                            <input type="button" value="'.$ccpa_settings['confirmbutton'].'" style="color: '.$ccpa_settings['button_text_color'].';">
                        </div>
                        <div class="clearboth"></div>
                    </div>
                </div>      
                <div class="confirmation-popup-close" style="background-color: '.$ccpa_settings['header_icon_background'].';">
                    <img src="'.$base_url .'/' .drupal_get_path('module', 'cookiepro_ccpa') .'/images/Close.svg" alt="Close Icon" title="Close Icon">
                </div>
            </div>

        </div>
    ';
    return $html;
}